/*
 * MP3Dispatch.c
 *
 * dispatch table for HS_MP3 shared library
 *
 * This wizard-generated code is based on code adapted from the
 * SampleLib project distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1994-1999 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
/* Our library public definitions (library API) */
#define BUILDING_MP3
#include "MP3.h"

/* Local prototypes */
Err MP3Install(UInt16 refNum, SysLibTblEntryType *entryP);
static MemPtr MP3DispatchTable(void);


Err MP3Install(UInt16 refNum, SysLibTblEntryType *entryP)
{
	#pragma unused(refNum)

	/* Install pointer to our dispatch table */
	entryP->dispatchTblP = (MemPtr *) MP3DispatchTable();
	
	/* Initialize globals pointer to zero (we will set up our
	 * library globals in the library "open" call). */
	entryP->globalsP = 0;

	return 0;
}

/* Palm OS uses short jumps */
#define prvJmpSize		4

/* Now, define a macro for offset list entries */
#define libDispatchEntry(index)		(kOffset+((index)*prvJmpSize))

/* Finally, define the size of the dispatch table's offset list --
 * it is equal to the size of each entry (which is presently 2
 * bytes) times the number of entries in the offset list (including
 * the @Name entry). */
#define numberOfAPIs        (5)
#define entrySize           (2)
#define	kOffset             (entrySize * (5 + numberOfAPIs))

static MemPtr asm MP3DispatchTable(void)
{
	LEA		@Table, A0			/* table ptr */
	RTS							/* exit with it */

@Table:
	/* Offset to library name */
	DC.W		@Name
	
	/*
	 * Library function dispatch entries
	 *
	 * ***IMPORTANT***
	 * The index parameters passed to the macro libDispatchEntry
	 * must be numbered consecutively, beginning with zero.
	 *
	 * The hard-wired values need to be used for offsets because
	 * CodeWarrior's inline assembler doesn't support label subtraction.
	 */
	
    /* Standard API entry points */
	DC.W		libDispatchEntry(0)			    /* MP3Open */
	DC.W		libDispatchEntry(1)		    	/* MP3Close */
	DC.W		libDispatchEntry(2)	    		/* MP3Sleep */
	DC.W		libDispatchEntry(3) 			/* MP3Wake */

    /* Custom API entry points */
    DC.W		libDispatchEntry(5 - 1)		/* MP3GetLibraryVer */
	DC.W		libDispatchEntry(6 - 1)		/* MP3StreamBuffer */
	DC.W		libDispatchEntry(7 - 1)		/* MP3DecoderInit */
	DC.W		libDispatchEntry(8 - 1)		/* MP3DecoderRun */
	DC.W		libDispatchEntry(9 - 1)		/* MP3DecoderFinish */

    /* Standard API entry points */
	JMP         MP3Open
	JMP         MP3Close
	JMP         MP3Sleep
	JMP         MP3Wake

    /* Custom API entry points */
    JMP			MP3GetLibraryVer
    JMP         MP3StreamBuffer
    JMP         MP3DecoderInit
    JMP         MP3DecoderRun
    JMP         MP3DecoderFinish
	
@Name:
	DC.B		"HS_MP3"
}
