/*
 * MP3Private.h
 *
 * header for implementation for shared library
 *
 * This wizard-generated code is based on code adapted from the
 * SampleLib project distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1994-1999 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#ifndef MP3PRIVATE_H_
#define MP3PRIVATE_H_

#include "config.h"
#include "MT.h"

/*********************************************************************
 * Private Functions
 *********************************************************************/
struct mad_layer3_tables *madimpl_get_layer3_tables(void *impl);

/*********************************************************************
 * Private Structures
 *********************************************************************/

/* Library globals */

typedef struct MP3GlobalsType
{
	/* MPEG Layer 3 tables from HS_MP3_Tables lib */
	MTTablesType layer3Tables;
	
	/* our library reference number (for convenience and debugging) */
	UInt16 thisLibRefNum;
	
	/* library open count */
	Int16 openCount;
	
	/* number of context in existence (for debugging) */
	Int16 contextCount;
	
	/* Layer 3 table library ref num */
	UInt16 tablesRefNum;
	
	/* Layer 3 table library client context */
	UInt32 tablesClientCtx;

	/* TODO: add other library globals here */
} MP3GlobalsType;

/* Client context structure for storing each client-specific data */

typedef struct MP3ClientContextType
{
	/* signature for validating the context based on
	 * address of MP3Open routine */
	void * libSignature;

	/* TODO: add other per-client variables here */

} MP3ClientContextType;

/*********************************************************************
 * Private Macros
 *********************************************************************/

#endif /* MP3PRIVATE_H_ */
