/*
 * MTDispatch.c
 *
 * dispatch table for HS_MP3_Tables shared library
 *
 * This wizard-generated code is based on code adapted from the
 * SampleLib project distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1994-1999 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
/* Our library public definitions (library API) */
#define BUILDING_MT
#include "MT.h"

/* Local prototypes */
Err MTInstall(UInt16 refNum, SysLibTblEntryType *entryP);
static MemPtr MTDispatchTable(void);


Err MTInstall(UInt16 refNum, SysLibTblEntryType *entryP)
{
	#pragma unused(refNum)

	/* Install pointer to our dispatch table */
	entryP->dispatchTblP = (MemPtr *) MTDispatchTable();
	
	/* Initialize globals pointer to zero (we will set up our
	 * library globals in the library "open" call). */
	entryP->globalsP = 0;

	return 0;
}

/* Palm OS uses short jumps */
#define prvJmpSize		4

/* Now, define a macro for offset list entries */
#define libDispatchEntry(index)		(kOffset+((index)*prvJmpSize))

/* Finally, define the size of the dispatch table's offset list --
 * it is equal to the size of each entry (which is presently 2
 * bytes) times the number of entries in the offset list (including
 * the @Name entry). */
#define numberOfAPIs        (3)
#define entrySize           (2)
#define	kOffset             (entrySize * (5 + numberOfAPIs))

static MemPtr asm MTDispatchTable(void)
{
	LEA		@Table, A0			/* table ptr */
	RTS							/* exit with it */

@Table:
	/* Offset to library name */
	DC.W		@Name
	
	/*
	 * Library function dispatch entries
	 *
	 * ***IMPORTANT***
	 * The index parameters passed to the macro libDispatchEntry
	 * must be numbered consecutively, beginning with zero.
	 *
	 * The hard-wired values need to be used for offsets because
	 * CodeWarrior's inline assembler doesn't support label subtraction.
	 */
	
    /* Standard API entry points */
	DC.W		libDispatchEntry(0)			    /* MTOpen */
	DC.W		libDispatchEntry(1)		    	/* MTClose */
	DC.W		libDispatchEntry(2)	    		/* MTSleep */
	DC.W		libDispatchEntry(3) 			/* MTWake */

    /* Custom API entry points */
	DC.W		libDispatchEntry(5 - 1)		/* MTGetTablesLE */
	DC.W		libDispatchEntry(6 - 1)		/* MTGetTablesBE */
	DC.W		libDispatchEntry(7 - 1)		/* MTFreeTables */

    /* Standard API entry points */
	JMP         MTOpen
	JMP         MTClose
	JMP         MTSleep
	JMP         MTWake

    /* Custom API entry points */
    JMP         MTGetTablesLE
    JMP         MTGetTablesBE
    JMP			MTFreeTables
	
@Name:
	DC.B		"HS_MP3_Tables"
}
